/* SIMulador Sistema PLAnetario, M.Alvarez 2018
 * Trabajo para el TFM
 * del Master de Astrofísica de la UAM
 * 
 * Copyright (c) 2018 Mariano Alvarez Fernandez (malfer@telefonica.net)
 *
 * This file is part of simspla
 *
 * simspla is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * simspla is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with rebound.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "simspla.h"

FILE *flog = NULL;
int glob_pstdio = 0;

int openlog(char *fname, int pstdio)
{
    flog = fopen(fname, "a");
    if (flog == NULL) {
        fprintf(stderr, "Error al crear el fichero de log %d\n", pstdio);
        return BAD_RETURN;
    }
    glob_pstdio = pstdio;
    return GOOD_RETURN;
}

void closelog(void)
{
    if (flog) fclose(flog);
}

void putslog(const char *text)
{
    if (!flog) return;
    fputs(text, flog);
    if (!glob_pstdio) return;
    fputs(text, stdout);
}

void printflog(const char *format, ...)
{
    va_list vargs;
    char s[401];
    
    if (!flog) return;
    
    va_start(vargs, format);
    vsnprintf(s, 400, format, vargs);
    fputs(s, flog);
    if (glob_pstdio)
        fputs(s, stdout);
    va_end(vargs);
}

void flushlog(void)
{
    if (!flog) return;
    fflush(flog);
}
